use crate::{APP_NAME, VERSION};
use poem::{handler, Body, IntoResponse, Response};
use tokio_util::io::ReaderStream;

const SOURCE_ARCHIVE: &[u8] = include_bytes!(concat!(env!("OUT_DIR"), "/archive.zip"));

/// Handle a request for source code of the server..
#[handler]
pub async fn handler() -> Result<Response, poem::Error> {
    let stream = ReaderStream::new(SOURCE_ARCHIVE);
    let body = Body::from_bytes_stream(stream);

    Ok(body
        .with_content_type("application/zip")
        .with_header(
            "Content-Disposition",
            format!("filename=\"{APP_NAME}-{VERSION}.zip\""),
        )
        .into_response())
}
